#pragma once
#include "types.h"

class CIrcMain;

#include "AsyncSocketEx.h"
#include "AsyncProxySocketLayer.h"

// By Maverick Added CIrcSocketBaseClass 
// to make it easier to change BaseSocket
#define CIrcSocketBaseClass CAsyncSocketEx

// By Maverick Added CIrcSocketBaseClass 
// to make it easier to change BaseSocket
class CIrcSocket : public CIrcSocketBaseClass
{
public:
	CIrcSocket(CIrcMain* pIrcMain);
	virtual ~CIrcSocket();
	int SendString(CString message);

public:
	void Connect();
	public:
	virtual void OnConnect(int nErrorCode);
	virtual void OnReceive(int nErrorCode);
	virtual void OnClose(int nErrorCode);
	virtual int OnLayerCallback(const CAsyncSocketExLayer *pLayer, int nType, int nParam1, int nParam2);
private:
	CIrcMain*	m_pIrcMain;
	CAsyncProxySocketLayer* m_pProxyLayer;

	void RemoveAllLayers();
};
