// Written by obaldin


#pragma once
#include "emule.h"
#include "KnownFile.h"

#if JUMPSTART

class CJumpstarter
{
public:
	CJumpstarter(CKnownFile* file);
	~CJumpstarter(void);

    static void OpenDatabases(DbEnv*	pDbEnvironment);
    static void CloseDatabases(void);

    static bool ShouldBeEnabledForFile(CKnownFile* file);
    static void EnableForFile(CKnownFile* file);

    void AddSentBlock(CUpDownClient* client,uint32 start_offset, uint32 togo);
    void WriteJumpstartPartStatus(CUpDownClient* client, CMemFile* file);

private:
    uint32 NumVisibleInChunksMap(uchar* chunks_map);
    static void AddHashName(DbTxn* tid, uchar* hash, char* name);

private:
    CKnownFile* kfile;
    uint32      nParts;

    static DbEnv*	pDbEnv;
	static Db*		pDbJumpstart;
	static Db*		pDbUserBlocks;
	static Db*		pDbUserChunks;
	static Db*		pDbHashNames;
};

#endif // JUMPSTART
